<?php
namespace nur\sery\schema;

class ref_schema {
  const SCHEMA_SCHEMA = [
    "type" => ["string", null, "" => 0,
      "required" => true,
      "desc" => "type de la valeur",
    ],
    "default" => [null, null, "" => 1,
      "desc" => "valeur par défaut",
    ],
    "key" => ["?key", null, "" => "",
      "desc" => "clé de la valeur si elle est dans un tableau",
    ],
    "required" => ["bool", false,
      "desc" => "cette valeur est-elle requise?",
    ],
    "formatter" => ["?callable", null,
      "desc" => "signature de la fonction: (value, format, type) => string",
    ],
    "parser" => ["?callable", null,
      "desc" => "signature de la fonction: (value, type) => [value, result]",
    ],
    "messages" => ["?array", null,
      "desc" => "message à afficher en cas d'erreur d'analyse",
    ],
  ];

  const MESSAGES = [
    "absent" => "{key}: Vous devez spécifier cette valeur",
    "null" => "{key}: Cette valeur ne doit pas être nulle",
    "invalid" => "{key}: {orig}: cette valeur est invalide",
  ];
}
